<!DOCTYPE html>
<html>

<head>
  <meta charset='utf-8'>
  <title>Pizza 365 project</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <p class="h3 text-center mt-5"> Chọn đồ uống </p>
    <div class="form-group col-12">
      <hr class="mt-5 mb-5" />
    </div>

    <div class="form-group">
      <label>Đồ uống:</label>
      <select id="drinking_select" class="form-control">
        <option>Chọn đồ uống</option>
      </select>
    </div>
    <button id="show-result" class="btn btn-primary w-25" onclick="onBtnDisplayClick()">Hiển thị</button>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm xử lý khi tải trang
    function onPageLoading(){
      "use strict";
      // Bước 1: Đọc - bỏ qua

      // Bước 2: kiểm tra - bỏ qua

      // Bước 3: Xử lý API
        var vXmlhttp = new XMLHttpRequest(); // Tạo đối tượng Request
        processAPI(vXmlhttp);
      // Bước 4: Đổ dữ liệu lên select
        vXmlhttp.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {            
            fillDataToSelect(vXmlhttp.responseText);
          }
        };
    }
    // Hàm xử lý khi click nút hiển thị
    function onBtnDisplayClick(){
      "use strict";
      // Bước 0: Tạo đối tượng thu thập
        var vObjectData = {
          drinkValue:"",
          drinkText:""
        }
      // Bước 1: Thu thập dữ liệu từ select
        getDataFromSelect(vObjectData);
        console.log(vObjectData);
      // Bước 2: Kiểm tra dữ liệu thu thập -  bỏ qua

      // Bước 3: Hiển thị kết quả
        displayData(vObjectData);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm hiển thị dữ liệu
    // input là đối tượng dữ liệu được chọn
    function displayData(paramObject){
      "use strict";
      console.log("Giá trị của select được chọn là: " + paramObject.drinkValue);
      console.log("Nội dung của select được chọn là: " + paramObject.drinkText);
    }
    // Hàm thu thập dữ liệu
    // Input là đối tượng chứa dữ liệu thu thập
    function getDataFromSelect(paramObject){
      "use strict";
      var vSelect = document.getElementById("drinking_select");
      paramObject.drinkValue =  vSelect.value;
      paramObject.drinkText =  vSelect.options[vSelect.selectedIndex].text;
    }
    // Hàm đổ dữ liệu vào select
    // input là dữ liệu từ serer gửi về
    function fillDataToSelect(paramData){
      "use strict";      
      var vObjectData = JSON.parse(paramData); // convert từ json string sang object
      console.log(vObjectData); //ghi response text ra console.log  

      var vSelect = document.getElementById('drinking_select');
      for (var bI = 0; bI < vObjectData.length; bI++){
        var bOpt = document.createElement('option');
        bOpt.value = vObjectData[bI].maNuocUong;
        bOpt.innerHTML = vObjectData[bI].tenNuocUong;
        vSelect.appendChild(bOpt);
      }

    }
    // hàm xử lý gửi yêu cầu đến server thông API
    // Input là đối tượng Request
    function processAPI(paramRequest){
      "use strict";
      paramRequest.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      paramRequest.send();
    }
    //mã nguồn để load data về
    function sampleCodeLoadData() {
      var xhttp = new XMLHttpRequest();
      xhttp.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            console.log(xhttp.responseText); //ghi response text ra console.log
          }
        };
      xhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      xhttp.send();
    }

  </script>
</body>

</html>